## keystone 13.0.4

=== debian/changelog ===
keystone (2:13.0.4-0ubuntu1) bionic-security; urgency=medium

  [ Chris MacNaughton ]
  * d/watch: Update to point at opendev.org.
  * New stable point release for OpenStack Queens (LP: #1893234).
    - d/p/0001-fixing-dn-to-id.patch: Dropped. Fixed in upstream
      release.

  [ Corey Bryant ]
  * SECURITY UPDATE: EC2 and/or credential endpoints are not protected
    from a scoped context. Keystone V3 /credentials endpoint policy
    logic allows to change credentials owner or target project ID.
    - debian/patches/CVE-2020-12689-CVE-2020-12691.patch: Fix security
      issues with EC2 credentials, addressing several issues in the
      creation and use of EC2/S3 credentials with keystone tokens.
    - CVE-2020-12689, CVE-2020-12691
  * SECURITY UPDATE: OAuth1 request token authorize silently ignores
    roles parameter.
    - debian/patches/CVE-2020-12690.patch: Ensure OAuth1 authorized
      roles are respected.
    - CVE-2020-12691
  * SECURITY UPDATE: Keystone doesn't check signature TTL of the EC2
    credential auth method.
    - debian/patches/CVE-2020-12692.patch: Check timestamp of signed
      EC2 token request.
    - CVE-2020-12692

 -- Corey Bryant <corey.bryant@canonical.com>  Fri, 28 Aug 2020 09:29:34 -0400

=== debian/control ===
Source: keystone
Section: net
Priority: extra
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Monty Taylor <mordred@inaugust.com>
Build-Depends:
 apache2-dev,
 debhelper (>= 10~),
 dh-apache2,
 dh-python,
 openstack-pkg-tools (>= 23~),
 python-all,
 python-pbr (>= 2.0.0),
 python-setuptools,
 python3-sphinx (>= 1.6.2),
Build-Depends-Indep:
 crudini,
 python-babel (>= 2.3.4),
 python-bashate (>= 0.5.1),
 python-bcrypt (>= 3.1.3),
 python-coverage (>= 4.0),
 python-cryptography (>= 1.9),
 python-dogpile.cache (>= 0.6.2),
 python-fixtures (>= 3.0.0),
 python-freezegun (>= 0.3.6),
 python-hacking (>= 0.12.0),
 python-jsonschema (>= 2.6.0),
 python-keystoneclient (>= 1:3.8.0),
 python-keystonemiddleware (>= 4.17.0),
 python-ldap,
 python-ldappool (>= 2.0.0),
 python-lxml (>= 3.4.1),
 python-memcache,
 python-migrate (>= 0.11.0),
 python-mock (>= 2.0.0),
 python-msgpack (>= 0.4.0),
 python-oauthlib (>= 0.6.0),
 python-openstackdocstheme (>= 1.18.1),
 python-os-api-ref (>= 1.4.0),
 python-os-testr (>= 1.0.0),
 python-oslo.cache (>= 1.26.0),
 python-oslo.concurrency (>= 3.25.0),
 python-oslo.config (>= 1:5.1.0),
 python-oslo.context (>= 1:2.19.2),
 python-oslo.db (>= 4.27.0),
 python-oslo.i18n (>= 3.15.3),
 python-oslo.log (>= 3.36.0),
 python-oslo.messaging (>= 5.29.0),
 python-oslo.middleware (>= 3.31.0),
 python-oslo.policy (>= 1.30.0),
 python-oslo.serialization (>= 2.18.0),
 python-oslo.utils (>= 3.33.0),
 python-oslotest (>= 1:3.2.0),
 python-osprofiler (>= 1.4.0),
 python-passlib (>= 1.7.0),
 python-paste (>= 2.0.2),
 python-pastedeploy (>= 1.5.0),
 python-pep8,
 python-pycadf (>= 1.1.0),
 python-pymongo,
 python-pymysql,
 python-pysaml2 (>= 4.0.2),
 python-requests (>= 2.14.2),
 python-routes (>= 2.3.1),
 python-scrypt (>= 0.8.0),
 python-six (>= 1.10.0),
 python-sqlalchemy (>= 1.0.10),
 python-stestr (>= 1.0.0),
 python-stevedore (>= 1:1.20.0),
 python-tempest (>= 1:17.1.0),
 python-testresources (>= 2.0.0),
 python-testtools (>= 2.2.0),
 python-tz (>= 2013.6),
 python-webob (>= 1:1.7.1),
 python-webtest (>= 2.0.27),
Standards-Version: 4.1.2
XS-Python-Version: >= 2.7
Homepage: http://launchpad.net/keystone
Vcs-Browser: https://git.launchpad.net/~ubuntu-server-dev/ubuntu/+source/keystone
Vcs-Git: git://git.launchpad.net/~ubuntu-server-dev/ubuntu/+source/keystone
XS-Testsuite: autopkgtest

Package: keystone
Architecture: all
Section: python
Depends:
 adduser,
 apache2 | httpd,
 libapache2-mod-wsgi,
 python-keystone (= ${source:Version}),
 ssl-cert (>= 1.0.12),
 ${misc:Depends},
 ${python:Depends},
Recommends:
 ${misc:Recommends},
Description: OpenStack identity service - Daemons
 Keystone is a proposed independent authentication service for OpenStack.
 .
 This initial proof of concept aims to address the current use cases in Swift
 and Nova which are:
 .
  * REST-based, token auth for Swift
  * many-to-many relationship between identity and tenant for Nova. Keystone
    does authentication and stuff
 .
 This package contains the daemons.

Package: keystone-doc
Architecture: all
Section: doc
Depends:
 libjs-jquery,
 ${misc:Depends},
Description: OpenStack identity service - Documentation
 Keystone is a proposed independent authentication service for OpenStack.
 .
 This initial proof of concept aims to address the current use cases in Swift
 and Nova which are:
 .
  * REST-based, token auth for Swift
  * many-to-many relationship between identity and tenant for Nova. Keystone
    does authentication and stuff
 .
 This package contains the documentation.

Package: python-keystone
Architecture: all
Section: python
Depends:
 python-babel (>= 2.3.4),
 python-bcrypt (>= 3.1.3),
 python-cryptography (>= 1.9),
 python-dogpile.cache (>= 0.6.2),
 python-jsonschema (>= 2.6.0),
 python-keystoneclient (>= 1:3.8.0),
 python-keystonemiddleware (>= 4.17.0),
 python-migrate (>= 0.11.0),
 python-msgpack (>= 0.4.0),
 python-oauthlib (>= 0.6.0),
 python-oslo.cache (>= 1.26.0),
 python-oslo.concurrency (>= 3.25.0),
 python-oslo.config (>= 1:5.1.0),
 python-oslo.context (>= 1:2.19.2),
 python-oslo.db (>= 4.27.0),
 python-oslo.i18n (>= 3.15.3),
 python-oslo.log (>= 3.36.0),
 python-oslo.messaging (>= 5.29.0),
 python-oslo.middleware (>= 3.31.0),
 python-oslo.policy (>= 1.30.0),
 python-oslo.serialization (>= 2.18.0),
 python-oslo.utils (>= 3.33.0),
 python-osprofiler (>= 1.4.0),
 python-passlib (>= 1.7.0),
 python-paste (>= 2.0.2),
 python-pastedeploy (>= 1.5.0),
 python-pbr (>= 2.0.0),
 python-pycadf (>= 1.1.0),
 python-pymysql,
 python-pysaml2 (>= 4.0.2),
 python-routes (>= 2.3.1),
 python-scrypt (>= 0.8.0),
 python-six (>= 1.10.0),
 python-sqlalchemy (>= 1.0.10),
 python-stevedore (>= 1:1.20.0),
 python-tz (>= 2013.6),
 python-webob (>= 1:1.7.1),
 ${misc:Depends},
 ${python:Depends},
Suggests:
 python-ldappool (>= 2.0.0),
 python-memcache,
 python-pyldap (>= 2.4.20),
Provides:
 ${python:Provides},
XB-Python-Version: ${python:Versions}
Description: OpenStack identity service - Python library
 Keystone is a proposed independent authentication service for OpenStack.
 .
 This initial proof of concept aims to address the current use cases in Swift
 and Nova which are:
 .
  * REST-based, token auth for Swift
  * many-to-many relationship between identity and tenant for Nova. Keystone
    does authentication and stuff
 .
 This package contains the Python libraries.

=== debian/watch ===
version=3
opts="uversionmangle=s/\.([a-zA-Z])/~$1/;s/%7E/~/;s/\.0b/~b/;s/\.0rc/~rc/" \
 https://tarballs.opendev.org/openstack/keystone keystone-(13\.\d.*)\.tar\.gz

## keystone 14.0.0

=== requirements.txt ===
# The order of packages is significant, because pip processes them in the order
# of appearance. Changing the order has an impact on the overall integration
# process, which may cause wedges in the gate later.

# Temporarily add Babel reference to avoid problem
# in keystone-coverage-db CI job
Babel!=2.4.0,>=2.3.4 # BSD

pbr!=2.1.0,>=2.0.0 # Apache-2.0
WebOb>=1.7.1 # MIT
Routes>=2.3.1 # MIT
Flask!=0.11,>=1.0.2  # BSD
Flask-RESTful>=0.3.5  # BSD
cryptography>=2.1 # BSD/Apache-2.0
six>=1.10.0 # MIT
SQLAlchemy!=1.1.5,!=1.1.6,!=1.1.7,!=1.1.8,>=1.0.10 # MIT
sqlalchemy-migrate>=0.11.0 # Apache-2.0
stevedore>=1.20.0 # Apache-2.0
passlib>=1.7.0 # BSD
python-keystoneclient>=3.8.0 # Apache-2.0
keystonemiddleware>=4.17.0 # Apache-2.0
bcrypt>=3.1.3 # Apache-2.0
scrypt>=0.8.0 # BSD
oslo.cache>=1.26.0 # Apache-2.0
oslo.concurrency>=3.26.0 # Apache-2.0
oslo.config>=5.2.0 # Apache-2.0
oslo.context>=2.21.0 # Apache-2.0
oslo.messaging>=5.29.0 # Apache-2.0
oslo.db>=4.27.0 # Apache-2.0
oslo.i18n>=3.15.3 # Apache-2.0
oslo.log>=3.36.0 # Apache-2.0
oslo.middleware>=3.31.0 # Apache-2.0
oslo.policy>=1.30.0 # Apache-2.0
oslo.serialization!=2.19.1,>=2.18.0 # Apache-2.0
oslo.utils>=3.33.0 # Apache-2.0
oauthlib>=0.6.2 # BSD
pysaml2>=4.5.0
dogpile.cache>=0.6.2 # BSD
jsonschema<3.0.0,>=2.6.0 # MIT
pycadf!=2.0.0,>=1.1.0 # Apache-2.0
msgpack>=0.4.0 # Apache-2.0
osprofiler>=1.4.0 # Apache-2.0
pytz>=2013.6 # MIT

=== debian/changelog ===
keystone (2:14.0.0-0ubuntu2) cosmic; urgency=medium

  * d/control: Set min python-oslo.log to rocky version (3.39.0) as
    requirements.txt min version is too low (LP: #1793347).

 -- Corey Bryant <corey.bryant@canonical.com>  Thu, 20 Sep 2018 11:15:39 +0200

keystone (2:14.0.0-0ubuntu1) cosmic; urgency=medium

  * New upstream release for OpenStack Rocky.

 -- Corey Bryant <corey.bryant@canonical.com>  Thu, 30 Aug 2018 10:32:45 -0400

keystone (2:14.0.0~rc1-0ubuntu2) cosmic; urgency=medium

  * d/keystone-common.apache2->keystone.apache2: Move apache2 site
    back to keystone package; its not common configuration and causes
    issues when python{3}-keystone is used by other packages that make
    use of Apache.

 -- James Page <james.page@ubuntu.com>  Thu, 16 Aug 2018 08:33:28 +0100

keystone (2:14.0.0~rc1-0ubuntu1) cosmic; urgency=medium

  * d/control: Align (Build-)Depends with upstream.
  * New upstream release candidate for OpenStack Rocky.

 -- James Page <james.page@ubuntu.com>  Tue, 14 Aug 2018 17:24:41 +0100

keystone (2:14.0.0~b3-0ubuntu1) cosmic; urgency=medium

  * New upstream milestone for OpenStack Rocky.
  * d/control: Align (Build-)Depends with upstream.

 -- Corey Bryant <corey.bryant@canonical.com>  Wed, 08 Aug 2018 10:07:43 -0400

keystone (2:14.0.0~b2-0ubuntu2) cosmic; urgency=medium

  * Add support for Python 3:
    - d/control: Add Py3 BDs and python3-keystone package.
    - d/control: Support Py2 first and Py3 as alternative.
    - d/control: Move all python deps to python(3)-keystone Depends.
    - d/control: Make python(3)-keystone conflict against each other.
    - d/control, d/rules, d/*.apache2, d/*.dirs, d/*.install, d/*.logrotate,
      d/*.manpages: Move common files to keystone-common and have python(3)-keystone
      depend on it.
    - d/rules: Add Py3 support.
    - d/rules: Use pkgos-dh_auto_install as this helps name binaries for
      update-alternatives.
    - d/rules: Run tests with pkgos-dh_auto_test.
    - d/python-keystone.install: Drop, not needed.
    - d/keystone.install: Drop usr/bin/* as pkgos-dh_auto_install handles
      install of those files.
    - d/python(3)-keystone.post*, d/python(3)-keystone.prerm: Add update-alternatives
      to enable correct shebangs for Python binaries.
    - d/tests/*: Enable Py3 tests for keystone daemons and add shebang tests.
    - d/tests/keystone-daemons: Use curl to test API.
  * d/rules: Set PYTHONPATH to include keystone when running tests.
  * d/control: Ensure python(3)-freezegun has Py3.7 fixes.

 -- Corey Bryant <corey.bryant@canonical.com>  Fri, 13 Jul 2018 15:01:37 -0400

keystone (2:14.0.0~b2-0ubuntu1) cosmic; urgency=medium

  * d/control: Drop python-pyldap as the fork has since been merged back
    into python-ldap.
  * New upstream milestone for OpenStack Rocky.
  * d/keystone.conf.dist, d/p/add-version-info.patch: Move the keystone.conf
    update to [extra_headers] that sets "Distribution = Ubuntu" from
    add-version-info.patch to debian/keystone.conf.dist.

 -- Corey Bryant <corey.bryant@canonical.com>  Wed, 13 Jun 2018 14:18:05 -0400

keystone (2:14.0.0~b1-0ubuntu1) cosmic; urgency=medium

  * d/watch: Scope to 14.x series.
  * New upstream milestone for OpenStack Rocky.
  * d/control: Align (Build-)Depends with upstream.
  * d/p/drop-sphinxcontrib-apidoc.patch: Drop sphinxcontrib.apidoc extension
    until package is available.
  * d/p/msgpack-python-compat.patch: Dropped. No longer needed.
  * d/control: Update Standards-Version to 4.1.4.
  * d/watch, d/control: Use https URLs.
  * d/control: Drop obsolete XS-Testsuite: autopkgtest header.
  * d/control, d/tests/*: Enable autopkgtest-pkg-python testsuite.

 -- Corey Bryant <corey.bryant@canonical.com>  Thu, 24 May 2018 14:23:02 -0700

=== debian/control ===
--- 
+++ 
@@ -12,6 +12,9 @@
  python-all,
  python-pbr (>= 2.0.0),
  python-setuptools,
+ python3-all,
+ python3-pbr (>= 2.0.0),
+ python3-setuptools,
  python3-sphinx (>= 1.6.2),
 Build-Depends-Indep:
  crudini,
@@ -19,10 +22,12 @@
  python-bashate (>= 0.5.1),
  python-bcrypt (>= 3.1.3),
  python-coverage (>= 4.0),
- python-cryptography (>= 1.9),
+ python-cryptography (>= 2.1),
  python-dogpile.cache (>= 0.6.2),
  python-fixtures (>= 3.0.0),
- python-freezegun (>= 0.3.6),
+ python-flask,
+ python-flask-restful,
+ python-freezegun (>= 0.3.9-1ubuntu1~),
  python-hacking (>= 0.12.0),
  python-jsonschema (>= 2.6.0),
  python-keystoneclient (>= 1:3.8.0),
@@ -34,17 +39,17 @@
  python-migrate (>= 0.11.0),
  python-mock (>= 2.0.0),
  python-msgpack (>= 0.4.0),
- python-oauthlib (>= 0.6.0),
+ python-oauthlib (>= 0.6.2),
  python-openstackdocstheme (>= 1.18.1),
  python-os-api-ref (>= 1.4.0),
  python-os-testr (>= 1.0.0),
  python-oslo.cache (>= 1.26.0),
- python-oslo.concurrency (>= 3.25.0),
- python-oslo.config (>= 1:5.1.0),
- python-oslo.context (>= 1:2.19.2),
+ python-oslo.concurrency (>= 3.26.0),
+ python-oslo.config (>= 1:5.2.0),
+ python-oslo.context (>= 1:2.21.0),
  python-oslo.db (>= 4.27.0),
  python-oslo.i18n (>= 3.15.3),
- python-oslo.log (>= 3.36.0),
+ python-oslo.log (>= 3.39.0),
  python-oslo.messaging (>= 5.29.0),
  python-oslo.middleware (>= 3.31.0),
  python-oslo.policy (>= 1.30.0),
@@ -59,7 +64,7 @@
  python-pycadf (>= 1.1.0),
  python-pymongo,
  python-pymysql,
- python-pysaml2 (>= 4.0.2),
+ python-pysaml2 (>= 4.5.0),
  python-requests (>= 2.14.2),
  python-routes (>= 2.3.1),
  python-scrypt (>= 0.8.0),
@@ -73,12 +78,73 @@
  python-tz (>= 2013.6),
  python-webob (>= 1:1.7.1),
  python-webtest (>= 2.0.27),
-Standards-Version: 4.1.2
+ python3-babel (>= 2.3.4),
+ python3-bashate (>= 0.5.1),
+ python3-bcrypt (>= 3.1.3),
+ python3-coverage (>= 4.0),
+ python3-cryptography (>= 2.1),
+ python3-dogpile.cache (>= 0.6.2),
+ python3-fixtures (>= 3.0.0),
+ python3-flask,
+ python3-flask-restful,
+ python3-freezegun (>= 0.3.9-1ubuntu1~),
+ python3-hacking (>= 0.12.0),
+ python3-jsonschema (>= 2.6.0),
+ python3-keystoneclient (>= 1:3.8.0),
+ python3-keystonemiddleware (>= 4.17.0),
+ python3-ldap,
+ python3-ldappool (>= 2.0.0),
+ python3-lxml (>= 3.4.1),
+ python3-memcache,
+ python3-migrate (>= 0.11.0),
+ python3-mock (>= 2.0.0),
+ python3-msgpack (>= 0.4.0),
+ python3-oauthlib (>= 0.6.2),
+ python3-openstackdocstheme (>= 1.18.1),
+ python3-os-api-ref (>= 1.4.0),
+ python3-os-testr (>= 1.0.0),
+ python3-oslo.cache (>= 1.26.0),
+ python3-oslo.concurrency (>= 3.26.0),
+ python3-oslo.config (>= 1:5.2.0),
+ python3-oslo.context (>= 1:2.21.0),
+ python3-oslo.db (>= 4.27.0),
+ python3-oslo.i18n (>= 3.15.3),
+ python3-oslo.log (>= 3.39.0),
+ python3-oslo.messaging (>= 5.29.0),
+ python3-oslo.middleware (>= 3.31.0),
+ python3-oslo.policy (>= 1.30.0),
+ python3-oslo.serialization (>= 2.18.0),
+ python3-oslo.utils (>= 3.33.0),
+ python3-oslotest (>= 1:3.2.0),
+ python3-osprofiler (>= 1.4.0),
+ python3-passlib (>= 1.7.0),
+ python3-paste (>= 2.0.2),
+ python3-pastedeploy (>= 1.5.0),
+ python3-pep8,
+ python3-pycadf (>= 1.1.0),
+ python3-pymongo,
+ python3-pymysql,
+ python3-pysaml2 (>= 4.5.0),
+ python3-reno (>= 2.5.0),
+ python3-requests (>= 2.14.2),
+ python3-routes (>= 2.3.1),
+ python3-scrypt (>= 0.8.0),
+ python3-six (>= 1.10.0),
+ python3-sqlalchemy (>= 1.0.10),
+ python3-stestr (>= 1.0.0),
+ python3-stevedore (>= 1:1.20.0),
+ python3-tempest (>= 1:17.1.0),
+ python3-testresources (>= 2.0.0),
+ python3-testtools (>= 2.2.0),
+ python3-tz (>= 2013.6),
+ python3-webob (>= 1:1.7.1),
+ python3-webtest (>= 2.0.27),
+Standards-Version: 4.1.4
 XS-Python-Version: >= 2.7
-Homepage: http://launchpad.net/keystone
+Homepage: https://launchpad.net/keystone
 Vcs-Browser: https://git.launchpad.net/~ubuntu-server-dev/ubuntu/+source/keystone
-Vcs-Git: git://git.launchpad.net/~ubuntu-server-dev/ubuntu/+source/keystone
-XS-Testsuite: autopkgtest
+Vcs-Git: https://git.launchpad.net/~ubuntu-server-dev/ubuntu/+source/keystone
+Testsuite: autopkgtest-pkg-python
 
 Package: keystone
 Architecture: all
@@ -86,11 +152,10 @@
 Depends:
  adduser,
  apache2 | httpd,
- libapache2-mod-wsgi,
- python-keystone (= ${source:Version}),
+ libapache2-mod-wsgi | libapache2-mod-wsgi-py3,
+ python-keystone (= ${source:Version}) | python3-keystone (= ${source:Version}),
  ssl-cert (>= 1.0.12),
  ${misc:Depends},
- ${python:Depends},
 Recommends:
  ${misc:Recommends},
 Description: OpenStack identity service - Daemons
@@ -127,23 +192,26 @@
 Architecture: all
 Section: python
 Depends:
+ keystone-common (= ${source:Version}),
  python-babel (>= 2.3.4),
  python-bcrypt (>= 3.1.3),
- python-cryptography (>= 1.9),
+ python-cryptography (>= 2.1),
  python-dogpile.cache (>= 0.6.2),
+ python-flask,
  python-jsonschema (>= 2.6.0),
+ python-ldap,
  python-keystoneclient (>= 1:3.8.0),
  python-keystonemiddleware (>= 4.17.0),
  python-migrate (>= 0.11.0),
  python-msgpack (>= 0.4.0),
- python-oauthlib (>= 0.6.0),
+ python-oauthlib (>= 0.6.2),
  python-oslo.cache (>= 1.26.0),
- python-oslo.concurrency (>= 3.25.0),
- python-oslo.config (>= 1:5.1.0),
- python-oslo.context (>= 1:2.19.2),
+ python-oslo.concurrency (>= 3.26.0),
+ python-oslo.config (>= 1:5.2.0),
+ python-oslo.context (>= 1:2.21.0),
  python-oslo.db (>= 4.27.0),
  python-oslo.i18n (>= 3.15.3),
- python-oslo.log (>= 3.36.0),
+ python-oslo.log (>= 3.39.0),
  python-oslo.messaging (>= 5.29.0),
  python-oslo.middleware (>= 3.31.0),
  python-oslo.policy (>= 1.30.0),
@@ -156,7 +224,7 @@
  python-pbr (>= 2.0.0),
  python-pycadf (>= 1.1.0),
  python-pymysql,
- python-pysaml2 (>= 4.0.2),
+ python-pysaml2 (>= 4.5.0),
  python-routes (>= 2.3.1),
  python-scrypt (>= 0.8.0),
  python-six (>= 1.10.0),
@@ -169,18 +237,102 @@
 Suggests:
  python-ldappool (>= 2.0.0),
  python-memcache,
- python-pyldap (>= 2.4.20),
 Provides:
  ${python:Provides},
 XB-Python-Version: ${python:Versions}
-Description: OpenStack identity service - Python library
- Keystone is a proposed independent authentication service for OpenStack.
- .
- This initial proof of concept aims to address the current use cases in Swift
- and Nova which are:
- .
-  * REST-based, token auth for Swift
-  * many-to-many relationship between identity and tenant for Nova. Keystone
-    does authentication and stuff
- .
- This package contains the Python libraries.
+Description: OpenStack identity service - Python 2 library
+ Keystone is a proposed independent authentication service for OpenStack.
+ .
+ This initial proof of concept aims to address the current use cases in Swift
+ and Nova which are:
+ .
+  * REST-based, token auth for Swift
+  * many-to-many relationship between identity and tenant for Nova. Keystone
+    does authentication and stuff
+ .
+ This package contains the Python 2 libraries.
+
+Package: python3-keystone
+Architecture: all
+Section: python
+Depends:
+ keystone-common (= ${source:Version}),
+ python3-babel (>= 2.3.4),
+ python3-bcrypt (>= 3.1.3),
+ python3-cryptography (>= 2.1),
+ python3-dogpile.cache (>= 0.6.2),
+ python3-flask,
+ python3-jsonschema (>= 2.6.0),
+ python3-ldap,
+ python3-keystoneclient (>= 1:3.8.0),
+ python3-keystonemiddleware (>= 4.17.0),
+ python3-migrate (>= 0.11.0),
+ python3-msgpack (>= 0.4.0),
+ python3-oauthlib (>= 0.6.2),
+ python3-oslo.cache (>= 1.26.0),
+ python3-oslo.concurrency (>= 3.26.0),
+ python3-oslo.config (>= 1:5.2.0),
+ python3-oslo.context (>= 1:2.21.0),
+ python3-oslo.db (>= 4.27.0),
+ python3-oslo.i18n (>= 3.15.3),
+ python3-oslo.log (>= 3.39.0),
+ python3-oslo.messaging (>= 5.29.0),
+ python3-oslo.middleware (>= 3.31.0),
+ python3-oslo.policy (>= 1.30.0),
+ python3-oslo.serialization (>= 2.18.0),
+ python3-oslo.utils (>= 3.33.0),
+ python3-osprofiler (>= 1.4.0),
+ python3-passlib (>= 1.7.0),
+ python3-paste (>= 2.0.2),
+ python3-pastedeploy (>= 1.5.0),
+ python3-pbr (>= 2.0.0),
+ python3-pycadf (>= 1.1.0),
+ python3-pymysql,
+ python3-pysaml2 (>= 4.5.0),
+ python3-routes (>= 2.3.1),
+ python3-scrypt (>= 0.8.0),
+ python3-six (>= 1.10.0),
+ python3-sqlalchemy (>= 1.0.10),
+ python3-stevedore (>= 1:1.20.0),
+ python3-tz (>= 2013.6),
+ python3-webob (>= 1:1.7.1),
+ ${misc:Depends},
+ ${python3:Depends},
+Suggests:
+ python3-ldappool (>= 2.0.0),
+ python3-memcache,
+Provides:
+ ${python3:Provides},
+XB-Python-Version: ${python3:Versions}
+Description: OpenStack identity service - Python 3 library
+ Keystone is a proposed independent authentication service for OpenStack.
+ .
+ This initial proof of concept aims to address the current use cases in Swift
+ and Nova which are:
+ .
+  * REST-based, token auth for Swift
+  * many-to-many relationship between identity and tenant for Nova. Keystone
+    does authentication and stuff
+ .
+ This package contains the Python 3 libraries.
+
+Package: keystone-common
+Architecture: all
+Section: python
+Depends:
+ ${misc:Depends},
+Breaks:
+ keystone (<< 2:14.0.0~b2-0ubuntu2~),
+Replaces:
+ keystone (<< 2:14.0.0~b2-0ubuntu2~),
+Description: OpenStack identity service - Common files
+ Keystone is a proposed independent authentication service for OpenStack.
+ .
+ This initial proof of concept aims to address the current use cases in Swift
+ and Nova which are:
+ .
+  * REST-based, token auth for Swift
+  * many-to-many relationship between identity and tenant for Nova. Keystone
+    does authentication and stuff
+ .
+ This package contains the common files.

## keystone 14.0.1

=== debian/changelog ===
keystone (2:14.0.1-2) unstable; urgency=medium

  * Add PY3_switch_to_using_unicode_text_values.patch and requires
    python3-ldappool >= 2.3.1, which fixes using ldap with Keystone under
    Python 3 (Closes: #923949).

 -- Thomas Goirand <zigo@debian.org>  Fri, 08 Mar 2019 12:19:47 +0100

keystone (2:14.0.1-1) unstable; urgency=medium

  [ Michal Arbet ]
  * New upstream version
  * d/control: Add me to uploaders field
  * d/copyright: Add me to copyright file

  [ Thomas Goirand ]
  * Update German debconf translation thanks to Chris Leick
    <c.leick@vollbio.de> (Closes: #910622).

 -- Thomas Goirand <zigo@debian.org>  Tue, 08 Jan 2019 09:38:02 +0100

keystone (2:14.0.0-2) unstable; urgency=medium

  * Do not run keystone.tests.unit.test_sql_upgrade tests, as it looks like
    broken if using SQLite (Closes: #909989).
  * Install correctly the examples folder into keystone-doc (ie: no nested
    examples folder).

 -- Thomas Goirand <zigo@debian.org>  Mon, 01 Oct 2018 08:50:53 +0200

keystone (2:14.0.0-1) unstable; urgency=medium

  * New upstream release.
  * Updated debconf translations, with thanks to:
    - fr.po, Julien Patriarca (Closes: #901433).
    - nl.po, Frans Spiesschaert (Closes: #898866).
  * Uploading to unstable.

 -- Thomas Goirand <zigo@debian.org>  Wed, 05 Sep 2018 13:04:10 +0200

keystone (2:14.0.0~rc1-1) experimental; urgency=medium

  * New upstream release.
  * Removed patches applied upstream:
    - remove_at_expression_from_tags.patch
    - CVE-2018-14432_Reduce_duplication_in_federated_auth_APIs.patch
  * Fixed (build-)depends for this release.

 -- Thomas Goirand <zigo@debian.org>  Mon, 20 Aug 2018 14:28:30 +0200

keystone (2:13.0.0-7) unstable; urgency=high

  [ Michal Arbet ]
  * Remove auth-token stuff

  [ Thomas Goirand ]
  * Removed using twice --bootstrap-region-id ${REGION_NAME} when doing the
    keystone bootstraping.
  * CVE-2018-14432: authenticated user may discover projects they have no
    authority to access, leaking all projects in the deployment and their
    attributes. Applie upstream patch for Ocata rebased to Newton: "Reduce
    duplication in federated auth APIs (Closes: #904616).

  [ Ondřej Nový ]
  * d/control: Use team+openstack@tracker.debian.org as maintainer

 -- Thomas Goirand <zigo@debian.org>  Fri, 06 Apr 2018 11:08:58 +0000

keystone (2:13.0.0-6) unstable; urgency=medium

  * Do not create role admin, created during bootstrap.
  * Added selection of endpoint protocol (ie: http / https).

 -- Thomas Goirand <zigo@debian.org>  Thu, 22 Mar 2018 12:12:14 +0000

keystone (2:13.0.0-5) unstable; urgency=medium

  * Switch back to Apache instead of uwsgi.

 -- Thomas Goirand <zigo@debian.org>  Thu, 08 Mar 2018 20:30:01 +0100

keystone (2:13.0.0-4) unstable; urgency=medium

  * Calls systemctl enable keystone-admin / keystone-public before starting.

 -- Thomas Goirand <zigo@debian.org>  Thu, 08 Mar 2018 16:26:30 +0100

keystone (2:13.0.0-3) unstable; urgency=medium

  * Switch back to using invoke-rc.d instead of service.
  * Remove option --no-orphans for uwsgi: this creates some 104 errors (ie: TCP
    connection reset by peer).

 -- Thomas Goirand <zigo@debian.org>  Thu, 08 Mar 2018 15:56:50 +0100

keystone (2:13.0.0-2) unstable; urgency=medium

  * Switch to using service start instead of invoke-rc.d to start keystone
    from postinst.

 -- Thomas Goirand <zigo@debian.org>  Thu, 08 Mar 2018 09:03:24 +0000

keystone (2:13.0.0-1) unstable; urgency=medium

  * New upstream release.
  * Switch to uwsgi instead of Apache.
  * Explicitely use python3 versions of config file generators.
  * Allow setting-up endpoints with IPv6 or FQDN when using debconf.
  * Handle policy.json correctly.

 -- Thomas Goirand <zigo@debian.org>  Tue, 06 Mar 2018 09:55:14 +0000

keystone (2:13.0.0~rc2-1) unstable; urgency=medium

  * New upstream rc release.
  * Uploading to unstable.
  * Add remove_at_expression_from_tags.patch.

 -- Thomas Goirand <zigo@debian.org>  Tue, 27 Feb 2018 10:31:50 +0000

keystone (2:13.0.0~rc1-2) unstable; urgency=medium

  * Uploading to unstable.

 -- Thomas Goirand <zigo@debian.org>  Tue, 27 Feb 2018 10:26:17 +0000

keystone (2:13.0.0~rc1-1) experimental; urgency=medium

  [ Thomas Goirand ]
  * Add new role, rating, needed for cloudkitty.

  [ Ondřej Nový ]
  * d/control: Set Vcs-* to salsa.debian.org
  * Running wrap-and-sort -bast

  [ Thomas Goirand ]
  * New upstream release.
  * Fixed (build-)depends for this release.
  * Standards-Version is now 4.1.3.
  * Fixed tests to use pkgos-dh_auto_test and stestr.
  * Remove init-system-helpers from depends, as it's essential.
  * Also package examples.
  * Remove dh-systemd.
  * Switched to Python 3:
    - Blacklist broken test: SAMLGenerationTests.test_sign_assertion_exc.

 -- Thomas Goirand <zigo@debian.org>  Wed, 14 Feb 2018 13:26:44 +0000

keystone (2:12.0.0-2) unstable; urgency=medium

  * Testing if a2dissite is available in postrm (Closes: #844448).
  * Uploading to unstable.

 -- Thomas Goirand <zigo@debian.org>  Wed, 01 Nov 2017 11:51:03 +0000

keystone (2:12.0.0-1) experimental; urgency=medium

  [ Daniel Baumann ]
  * Updating vcs fields.
  * Updating copyright format url.
  * Updating maintainer field.
  * Running wrap-and-sort -bast.
  * Updating standards version to 4.0.0.
  * Removing gbp.conf, not used anymore or should be specified in the
    developers dotfiles.
  * Correcting permissions in debian packaging files.
  * Updating standards version to 4.0.1.
  * Deprecating priority extra as per policy 4.0.1.
  * Updating standards version to 4.1.0.

  [ Thomas Goirand ]
  * New upstream release.
  * Fixed (build-)depends for this release.
  * Removed obsolete patches.
  * Allow Babel 2.4.0 (patch requirements.txt).
  * Do not install policy.json and keystone.py/wsgi.py.
  * Do not use --noverbose when doing db_sync.
  * Fixed generating keystone.conf and now generating keystone.policy.yaml.
  * Create a MANIFEST.in to install missing migration files.


## keystone 14.1.0

=== debian/changelog ===
keystone (2:14.1.0-0ubuntu1) cosmic; urgency=medium

  * New upstream release for OpenStack Rocky (LP: #1830695).
  * d/p/py3-switch-to-using-unicode-text-values.patch: Dropped. Already in
    14.1.0.
  * d/p/ensure-LDAP-searches-use-unicode-attributes.patch: Dropped. Already in
    14.1.0.

 -- Sahid Orentino Ferdjaoui <sahid.ferdjaoui@canonical.com>  Tue, 11 Jun 2019 16:39:26 +0200

keystone (2:14.0.1-0ubuntu3) cosmic; urgency=medium

  * d/control, d/p/py3-switch-to-using-unicode-text-values.patch: Enable
    Keystone LDAP Python 3 support. Patch is cherry-picked from
    https://review.openstack.org/613648 (LP: #1798184).
  * d/p/ensure-LDAP-searches-use-unicode-attributes.patch: Cherry-picked
    from https://review.openstack.org/#/c/643670/ to fix LDAP backend
    searches (LP: #1820333).

 -- Corey Bryant <corey.bryant@canonical.com>  Tue, 19 Mar 2019 07:35:02 -0400

keystone (2:14.0.1-0ubuntu2) cosmic; urgency=medium

  * d/control, d/p/py3-switch-to-using-unicode-text-values.patch: Enable
    Keystone LDAP Python 3 support. Patch is cherry-picked from
    https://review.openstack.org/613648 (LP: #1798184).

 -- Corey Bryant <corey.bryant@canonical.com>  Wed, 13 Mar 2019 11:31:48 -0400

keystone (2:14.0.1-0ubuntu1) cosmic; urgency=medium

  * d/gbp.conf: Create stable/rocky branch.
  * New stable point release for OpenStack Rocky (LP: #1806049).

 -- Corey Bryant <corey.bryant@canonical.com>  Mon, 03 Dec 2018 12:21:00 -0500

=== debian/watch ===
version=3
opts="uversionmangle=s/\.([a-zA-Z])/~$1/;s/%7E/~/;s/\.0b/~b/;s/\.0rc/~rc/" \
 https://tarballs.openstack.org/keystone keystone-(14\.\d.*)\.tar\.gz

## keystone 14.2.0

=== requirements.txt ===
--- 
+++ 
@@ -28,7 +28,7 @@
 oslo.messaging>=5.29.0 # Apache-2.0
 oslo.db>=4.27.0 # Apache-2.0
 oslo.i18n>=3.15.3 # Apache-2.0
-oslo.log>=3.36.0 # Apache-2.0
+oslo.log>=3.38.0 # Apache-2.0
 oslo.middleware>=3.31.0 # Apache-2.0
 oslo.policy>=1.30.0 # Apache-2.0
 oslo.serialization!=2.19.1,>=2.18.0 # Apache-2.0

=== doc/requirements.txt ===
# The order of packages is significant, because pip processes them in the order
# of appearance. Changing the order has an impact on the overall integration
# process, which may cause wedges in the gate later.
openstackdocstheme>=1.18.1 # Apache-2.0
sphinx!=1.6.6,!=1.6.7,>=1.6.2 # BSD
sphinxcontrib-apidoc>=0.2.0  # BSD
reno>=2.5.0 # Apache-2.0
os-api-ref>=1.4.0 # Apache-2.0
python-ldap>=3.0.0  # PSF
ldappool>=2.0.0 # MPL

=== debian/changelog ===
keystone (2:14.2.0-0ubuntu1~cloud1) bionic-rocky; urgency=medium

  * d/watch: Switch to opendev.org.
  * New stable point release for OpenStack Rocky (LP: #1875462).
  * d/p/000*-fixing-dn-to-id.patch: Dropped. Fixed in new stable
    point release.

 -- Corey Bryant <corey.bryant@canonical.com>  Tue, 05 May 2020 13:22:39 -0400

keystone (2:14.1.0-0ubuntu1.1~cloud1) bionic-rocky; urgency=medium

  * d/p/000*-fixing-dn-to-id.patch: Fix LDAP backend's dn_to_id function
    for cases were id is not in the DN (LP: #1782922).

 -- Corey Bryant <corey.bryant@canonical.com>  Wed, 18 Sep 2019 11:15:56 +0200

keystone (2:14.1.0-0ubuntu1.1~cloud0) bionic; urgency=medium

  * d/p/token-consistently-decode-binary-types.patch: Ensure binary
    types are consistently decoded under Python 3 (LP: #1832265).

 -- James Page <james.page@ubuntu.com>  Fri, 14 Jun 2019 06:07:00 +0100

=== debian/control ===
--- 
+++ 
@@ -33,7 +33,7 @@
  python-keystoneclient (>= 1:3.8.0),
  python-keystonemiddleware (>= 4.17.0),
  python-ldap,
- python-ldappool (>= 2.0.0),
+ python-ldappool (>= 2.2.0-3ubuntu2~),
  python-lxml (>= 3.4.1),
  python-memcache,
  python-migrate (>= 0.11.0),
@@ -93,7 +93,7 @@
  python3-keystoneclient (>= 1:3.8.0),
  python3-keystonemiddleware (>= 4.17.0),
  python3-ldap,
- python3-ldappool (>= 2.0.0),
+ python3-ldappool (>= 2.2.0-3ubuntu2~),
  python3-lxml (>= 3.4.1),
  python3-memcache,
  python3-migrate (>= 0.11.0),
@@ -235,7 +235,7 @@
  ${misc:Depends},
  ${python:Depends},
 Suggests:
- python-ldappool (>= 2.0.0),
+ python-ldappool (>= 2.2.0-3ubuntu2~),
  python-memcache,
 Provides:
  ${python:Provides},
@@ -299,7 +299,7 @@
  ${misc:Depends},
  ${python3:Depends},
 Suggests:
- python3-ldappool (>= 2.0.0),
+ python3-ldappool (>= 2.2.0-3ubuntu2~),
  python3-memcache,
 Provides:
  ${python3:Provides},

=== debian/rules ===
#!/usr/bin/make -f

# Verbose mode
#export DH_VERBOSE=1

DEBVERS ?= $(shell dpkg-parsechangelog | sed -n -e 's/^Version: //p')
VERSION ?= $(shell echo '$(DEBVERS)' | sed -e 's/^[[:digit:]]*://' -e 's/[-].*//' -e 's/~/./g')
export PBR_VERSION=$(VERSION)
SHELL := /bin/sh -e

include /usr/share/openstack-pkg-tools/pkgos.make

# auth_token middleware now requires access to HOME, otherwise
# test suite cause FTBFS.  See (LP: #1031022)
#export HOME="$(CURDIR)/debian/tests/"

%:
	dh $@ --with apache2,python2,python3,systemd

ifeq (,$(findstring nocheck, $(DEB_BUILD_OPTIONS)))
override_dh_auto_test:
	mkdir -p $(CURDIR)/keystone/tests/tmp
	PYTHONPATH=$(CURDIR) pkgos-dh_auto_test
endif

override_dh_auto_build:
	dh_auto_build
ifeq (,$(findstring nodocs, $(DEB_BUILD_OPTIONS)))
	mkdir -p $(CURDIR)/doc/build/html
	mkdir -p $(CURDIR)/doc/build/man
	sphinx-build -b man doc/source doc/build/man
	sphinx-build -b html doc/source doc/build/html
endif

override_dh_auto_install:
	echo "Do nothing..."

override_dh_install:
	pkgos-dh_auto_install
	rm -rf $(CURDIR)/debian/python-keystone/usr/etc
	rm -rf $(CURDIR)/debian/python3-keystone/usr/etc
	dh_install --fail-missing
	install -D -m 0600 $(CURDIR)/etc/logging.conf.sample  $(CURDIR)/debian/keystone-common/etc/keystone/logging.conf
	PYTHONPATH=$(CURDIR) oslo-config-generator --config-file=config-generator/keystone.conf \
		--output-file=$(CURDIR)/debian/keystone-common/etc/keystone/keystone.conf
	PYTHONPATH=$(CURDIR) oslopolicy-sample-generator --config-file=config-generator/keystone-policy-generator.conf \
		--output-file=$(CURDIR)/debian/keystone-common/etc/keystone/keystone.policy.yaml
	crudini --merge $(CURDIR)/debian/keystone-common/etc/keystone/keystone.conf < $(CURDIR)/debian/keystone.conf.dist

override_dh_clean:
	rm -rf $(CURDIR)/build $(CURDIR)/keystone.egg-info $(CURDIR)/.cache
	rm -rf $(CURDIR)/keystone/tests/tmp
	rm -rf $(CURDIR)/.testrepository
	rm -rf $(CURDIR)/debian/tmp
	rm -rf $(CURDIR)/doc/build
	# NOTE(adam_g) The following stuff is built in /doc/source.  Safe for now, but
	# should be fixed upstream or updated here post-essex 
	rm -rf $(CURDIR)/doc/source/keystone*.rst
	rm -rf $(CURDIR)/doc/source/modules.rst
	rm -f debian/*.init debian/*.service debian/*.upstart
	dh_clean

override_dh_auto_clean:
	dh_auto_clean
	rm -rf .eggs .testrepository

=== debian/tests/control ===
Tests: keystone-daemon, keystone-shebangs-py3
Depends: python3-keystone, libapache2-mod-wsgi-py3, keystone
Restrictions: needs-root

Tests: keystone-daemon, keystone-shebangs-py2
Depends: keystone
Restrictions: needs-root

=== debian/watch ===
version=3
opts="uversionmangle=s/\.([a-zA-Z])/~$1/;s/%7E/~/;s/\.0b/~b/;s/\.0rc/~rc/" \
 https://tarballs.opendev.org/openstack/keystone keystone-(14\.\d.*)\.tar\.gz

## keystone 15.0.0

=== debian/changelog ===
keystone (2:15.0.0-0ubuntu1) disco; urgency=medium

  * New upstream release for OpenStack Stein.

 -- James Page <james.page@ubuntu.com>  Fri, 12 Apr 2019 09:10:50 +0100

keystone (2:15.0.0~rc2-0ubuntu1) disco; urgency=medium

  * New upstream release candidate for OpenStack Stein.

 -- Sahid Orentino Ferdjaoui <sahid.ferdjaoui@canonical.com>  Fri, 05 Apr 2019 14:22:09 +0200

keystone (2:15.0.0~rc1-0ubuntu1) disco; urgency=medium

  * d/watch: Track 15.x series.
  * New upstream release candidate for OpenStack Stein.
  * d/p/ensure-LDAP-searches-use-unicode-attributes.patch: Drop,
    included upstream.

 -- James Page <james.page@ubuntu.com>  Thu, 21 Mar 2019 16:45:45 +0000

keystone (2:15.0.0~b1~git2019031401.2c7bb275f-0ubuntu2) disco; urgency=medium

  * d/p/ensure-LDAP-searches-use-unicode-attributes.patch: Cherry-picked
    from https://review.openstack.org/#/c/643670/ to fix LDAP backend
    searches (LP: #1820333).

 -- Corey Bryant <corey.bryant@canonical.com>  Tue, 19 Mar 2019 07:26:22 -0400

keystone (2:15.0.0~b1~git2019031401.2c7bb275f-0ubuntu1) disco; urgency=medium

  * New upstream snapshot for OpenStack Stein.
  * d/control: Align (Build-)Depends with upstream.

 -- James Page <james.page@ubuntu.com>  Thu, 14 Mar 2019 07:19:19 +0000

keystone (2:15.0.0~b1~git2019013050.64ffe8c65-0ubuntu1) disco; urgency=medium

  * New upstream snapshot for OpenStack Stein.
  * d/control: Align (Build-)Depends with upstream.
  * d/p/*: Rebase.

 -- James Page <james.page@ubuntu.com>  Wed, 30 Jan 2019 17:35:16 +0000

keystone (2:15.0.0~b1~git2018111457.b7dfb72a6-0ubuntu1) disco; urgency=medium

  * New upstream snapshot for OpenStack Stein.
  * d/p/*: Refresh.
  * d/control: Align (Build-)Depends with upstream.
  * d/control,python3-keystone.*: Make Python 3 modules the primary runtime
    dependency.
  * d/rules,tests/keystone-shebangs-py3: Use major version only for shebangs.
  * d/control,rules: Switch to Python 3 only.
  * d/tests: Update for Python 3 only.
  * d/keystone-common.install: Drop install of keystone-paste.ini with
    switch to flask.

 -- James Page <james.page@ubuntu.com>  Thu, 15 Nov 2018 11:32:30 +0000

keystone (2:14.0.0-0ubuntu3) disco; urgency=medium

  * d/tests/keystone-shebangs-py3: Update shebang for Python 3.7.

 -- Corey Bryant <corey.bryant@canonical.com>  Wed, 07 Nov 2018 09:51:28 -0500

=== debian/watch ===
version=3
opts="uversionmangle=s/\.([a-zA-Z])/~$1/;s/%7E/~/;s/\.0b/~b/;s/\.0rc/~rc/" \
 https://tarballs.openstack.org/keystone keystone-(15\.\d.*)\.tar\.gz
